3 # Copyright (c) 2005 Junio C Hamano
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff|--ff-only] [--[no-]rebase|--rebase=preserve] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and integrate it/them with the current HEAD.'
13 set_reflog_action "pull${1+ $*}"
14 require_work_tree_exists
19 git diff-index --cached --name-status -r --ignore-submodules HEAD --
20 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
21 die "$(gettext "Pull is not possible because you have unmerged files.
22 Please, fix them up in the work tree, and then use 'git add/rm <file>'
23 as appropriate to mark resolution, or use 'git commit -a'.")"
25 die "$(gettext "Pull is not possible because you have unmerged files.")"
30 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
31 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
32 Please, commit your changes before you can merge.")"
34 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
38 test -z "$(git ls-files -u)" || die_conflict
39 test -f "$GIT_DIR/MERGE_HEAD" && die_merge
41 bool_or_string_config () {
42 git config --bool "$1" 2>/dev/null || git config "$1"
45 strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
46 log_arg= verbosity= progress= recurse_submodules= verify_signatures=
47 merge_args= edit= rebase_args=
48 curr_branch=$(git symbolic-ref -q HEAD)
49 curr_branch_short="${curr_branch#refs/heads/}"
50 rebase=$(bool_or_string_config branch.$curr_branch_short.rebase)
53 rebase=$(bool_or_string_config pull.rebase)
56 # Setup default fast-forward options via `pull.ff`
57 pull_ff=$(git config pull.ff)
75 verbosity="$verbosity -q" ;;
77 verbosity="$verbosity -v" ;;
79 progress=--progress ;;
81 progress=--no-progress ;;
82 -n|--no-stat|--no-summary)
88 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
89 no_commit=--no-commit ;;
90 --c|--co|--com|--comm|--commi|--commit)
96 --sq|--squ|--squa|--squas|--squash)
98 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
106 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
107 --strateg=*|--strategy=*|\
108 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
111 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
118 strategy_args="${strategy_args}-s $strategy "
125 xx="-X $(git rev-parse --sq-quote "$2")"
128 xx=$(git rev-parse --sq-quote "$1") ;;
130 merge_args="$merge_args$xx "
132 -r=*|--r=*|--re=*|--reb=*|--reba=*|--rebas=*|--rebase=*)
135 -r|--r|--re|--reb|--reba|--rebas|--rebase)
138 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
141 --recurse-submodules)
142 recurse_submodules=--recurse-submodules
144 --recurse-submodules=*)
145 recurse_submodules="$1"
147 --no-recurse-submodules)
148 recurse_submodules=--no-recurse-submodules
151 verify_signatures=--verify-signatures
153 --no-verify-signatures)
154 verify_signatures=--no-verify-signatures
160 gpg_sign_args=$(git rev-parse --sq-quote "-S${1#--gpg-sign=}")
163 gpg_sign_args=$(git rev-parse --sq-quote "$1")
165 --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
172 # Pass thru anything that may be meant for fetch.
182 rebase_args=--preserve-merges
187 echo "Invalid value for --rebase, should be true, false, or preserve"
193 error_on_no_merge_candidates () {
198 -t|--t|--ta|--tag|--tags)
199 echo "It doesn't make sense to pull all tags; you probably meant:"
200 echo " git fetch --tags"
205 if test true = "$rebase"
214 upstream=$(git config "branch.$curr_branch_short.merge")
215 remote=$(git config "branch.$curr_branch_short.remote")
217 if [ $# -gt 1 ]; then
218 if [ "$rebase" = true ]; then
219 printf "There is no candidate for rebasing against "
221 printf "There are no candidates for merging "
223 echo "among the refs that you just fetched."
224 echo "Generally this means that you provided a wildcard refspec which had no"
225 echo "matches on the remote end."
226 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
227 echo "You asked to pull from the remote '$1', but did not specify"
228 echo "a branch. Because this is not the default configured remote"
229 echo "for your current branch, you must specify a branch on the command line."
230 elif [ -z "$curr_branch" -o -z "$upstream" ]; then
232 error_on_missing_default_upstream "pull" $op_type $op_prep \
233 "git pull <remote> <branch>"
235 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
236 echo "from the remote, but no such ref was fetched."
241 test true = "$rebase" && {
242 if ! git rev-parse -q --verify HEAD >/dev/null
244 # On an unborn branch
245 if test -f "$GIT_DIR/index"
247 die "$(gettext "updating an unborn branch with changes added to the index")"
250 require_clean_work_tree "pull with rebase" "Please commit or stash them."
253 test -n "$curr_branch" &&
254 . git-parse-remote &&
255 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
256 oldremoteref=$(git merge-base --fork-point "$remoteref" $curr_branch 2>/dev/null)
258 orig_head=$(git rev-parse -q --verify HEAD)
259 git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
260 test -z "$dry_run" || exit 0
262 curr_head=$(git rev-parse -q --verify HEAD)
263 if test -n "$orig_head" && test "$curr_head" != "$orig_head"
265 # The fetch involved updating the current branch.
267 # The working tree and the index file is still based on the
268 # $orig_head commit, but we are merging into $curr_head.
269 # First update the working tree to match $curr_head.
271 eval_gettextln "Warning: fetch updated the current branch head.
272 Warning: fast-forwarding your working tree from
273 Warning: commit \$orig_head." >&2
274 git update-index -q --refresh
275 git read-tree -u -m "$orig_head" "$curr_head" ||
276 die "$(eval_gettext "Cannot fast-forward your working tree.
277 After making sure that you saved anything precious from
278 $ git diff \$orig_head
285 merge_head=$(sed -e '/ not-for-merge /d' \
286 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
289 case "$merge_head" in
291 error_on_no_merge_candidates "$@"
294 if test -z "$orig_head"
296 die "$(gettext "Cannot merge multiple branches into empty head")"
298 if test true = "$rebase"
300 die "$(gettext "Cannot rebase onto multiple branches")"
305 # Pulling into unborn branch: a shorthand for branching off
306 # FETCH_HEAD, for lazy typers.
307 if test -z "$orig_head"
309 # Two-way merge: we claim the index is based on an empty tree,
310 # and try to fast-forward to HEAD. This ensures we will not
311 # lose index/worktree changes that the user already made on
313 empty_tree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
314 git read-tree -m -u $empty_tree $merge_head &&
315 git update-ref -m "initial pull" HEAD $merge_head "$curr_head"
319 if test true = "$rebase"
321 o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
322 if test "$oldremoteref" = "$o"
328 merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit
331 eval="git-rebase $diffstat $strategy_args $merge_args $rebase_args $verbosity"
332 eval="$eval $gpg_sign_args"
333 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
336 eval="git-merge $diffstat $no_commit $verify_signatures $edit $squash $no_ff $ff_only"
337 eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
338 eval="$eval $gpg_sign_args"
339 eval="$eval \"\$merge_name\" HEAD $merge_head"